
From: David Howells <dhowells@redhat.com>

The attached patch makes calibrate_delay() optional. In this architecture, it's
a waste of time since we can predict exactly what it's going to come up with
just by looking at the CPU's hardware clock registers. Thus far, we haven't
seen a board with any clock not dependent on the CPU's clock.

Signed-Off-By: David Howells <dhowells@redhat.com>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/arch/alpha/Kconfig         |    4 +
 25-akpm/arch/arm/Kconfig           |    4 +
 25-akpm/arch/arm26/Kconfig         |    4 +
 25-akpm/arch/cris/Kconfig          |    4 +
 25-akpm/arch/h8300/Kconfig         |    4 +
 25-akpm/arch/i386/Kconfig          |    4 +
 25-akpm/arch/ia64/Kconfig          |    4 +
 25-akpm/arch/m32r/Kconfig          |    4 +
 25-akpm/arch/m68k/Kconfig          |    4 +
 25-akpm/arch/m68knommu/Kconfig     |    4 +
 25-akpm/arch/mips/Kconfig          |    4 +
 25-akpm/arch/parisc/Kconfig        |    4 +
 25-akpm/arch/ppc/Kconfig           |    4 +
 25-akpm/arch/ppc64/Kconfig         |    4 +
 25-akpm/arch/s390/Kconfig          |    4 +
 25-akpm/arch/sh/Kconfig            |    4 +
 25-akpm/arch/sh64/Kconfig          |    4 +
 25-akpm/arch/sparc/Kconfig         |    4 +
 25-akpm/arch/sparc64/Kconfig       |    4 +
 25-akpm/arch/um/Kconfig            |    4 +
 25-akpm/arch/v850/Kconfig          |    3 +
 25-akpm/arch/x86_64/Kconfig        |    4 +
 25-akpm/include/asm-m32r/smp.h     |    1 
 25-akpm/include/asm-x86_64/proto.h |    1 
 25-akpm/include/linux/delay.h      |    1 
 25-akpm/init/Makefile              |    2 
 25-akpm/init/calibrate.c           |   79 +++++++++++++++++++++++++++++++++++++
 25-akpm/init/main.c                |   70 --------------------------------
 28 files changed, 169 insertions(+), 72 deletions(-)

diff -puN arch/alpha/Kconfig~frv-make-calibrate_delay-optional arch/alpha/Kconfig
--- 25/arch/alpha/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/alpha/Kconfig	Mon Nov  8 15:00:49 2004
@@ -28,6 +28,10 @@ config RWSEM_XCHGADD_ALGORITHM
 	bool
 	default y
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config GENERIC_ISA_DMA
 	bool
 	default y
diff -puN arch/arm26/Kconfig~frv-make-calibrate_delay-optional arch/arm26/Kconfig
--- 25/arch/arm26/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/arm26/Kconfig	Mon Nov  8 15:00:49 2004
@@ -45,6 +45,10 @@ config RWSEM_GENERIC_SPINLOCK
 config RWSEM_XCHGADD_ALGORITHM
 	bool
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config GENERIC_BUST_SPINLOCK
 	bool
 
diff -puN arch/arm/Kconfig~frv-make-calibrate_delay-optional arch/arm/Kconfig
--- 25/arch/arm/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/arm/Kconfig	Mon Nov  8 15:00:49 2004
@@ -57,6 +57,10 @@ config RWSEM_GENERIC_SPINLOCK
 config RWSEM_XCHGADD_ALGORITHM
 	bool
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config GENERIC_BUST_SPINLOCK
 	bool
 
diff -puN arch/cris/Kconfig~frv-make-calibrate_delay-optional arch/cris/Kconfig
--- 25/arch/cris/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/cris/Kconfig	Mon Nov  8 15:00:49 2004
@@ -20,6 +20,10 @@ config RWSEM_GENERIC_SPINLOCK
 config RWSEM_XCHGADD_ALGORITHM
 	bool
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config CRIS
 	bool
 	default y
diff -puN arch/h8300/Kconfig~frv-make-calibrate_delay-optional arch/h8300/Kconfig
--- 25/arch/h8300/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/h8300/Kconfig	Mon Nov  8 15:00:49 2004
@@ -33,6 +33,10 @@ config RWSEM_XCHGADD_ALGORITHM
 	bool
 	default n
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config ISA
 	bool
 	default y
diff -puN arch/i386/Kconfig~frv-make-calibrate_delay-optional arch/i386/Kconfig
--- 25/arch/i386/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/i386/Kconfig	Mon Nov  8 15:00:49 2004
@@ -373,6 +373,10 @@ config RWSEM_XCHGADD_ALGORITHM
 	depends on !M386
 	default y
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config X86_PPRO_FENCE
 	bool
 	depends on M686 || M586MMX || M586TSC || M586 || M486 || M386
diff -puN arch/ia64/Kconfig~frv-make-calibrate_delay-optional arch/ia64/Kconfig
--- 25/arch/ia64/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/ia64/Kconfig	Mon Nov  8 15:00:49 2004
@@ -30,6 +30,10 @@ config RWSEM_XCHGADD_ALGORITHM
 	bool
 	default y
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config TIME_INTERPOLATION
 	bool
 	default y
diff -puN arch/m32r/Kconfig~frv-make-calibrate_delay-optional arch/m32r/Kconfig
--- 25/arch/m32r/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/m32r/Kconfig	Mon Nov  8 15:00:49 2004
@@ -189,6 +189,10 @@ config RWSEM_XCHGADD_ALGORITHM
 	bool
 	default n
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config PREEMPT
 	bool "Preemptible Kernel"
 	help
diff -puN arch/m68k/Kconfig~frv-make-calibrate_delay-optional arch/m68k/Kconfig
--- 25/arch/m68k/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/m68k/Kconfig	Mon Nov  8 15:00:49 2004
@@ -21,6 +21,10 @@ config RWSEM_GENERIC_SPINLOCK
 config RWSEM_XCHGADD_ALGORITHM
 	bool
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 mainmenu "Linux/68k Kernel Configuration"
 
 source "init/Kconfig"
diff -puN arch/m68knommu/Kconfig~frv-make-calibrate_delay-optional arch/m68knommu/Kconfig
--- 25/arch/m68knommu/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/m68knommu/Kconfig	Mon Nov  8 15:00:49 2004
@@ -29,6 +29,10 @@ config RWSEM_XCHGADD_ALGORITHM
 	bool
 	default n
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 source "init/Kconfig"
 
 menu "Processor type and features"
diff -puN arch/mips/Kconfig~frv-make-calibrate_delay-optional arch/mips/Kconfig
--- 25/arch/mips/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/mips/Kconfig	Mon Nov  8 15:00:49 2004
@@ -826,6 +826,10 @@ config RWSEM_GENERIC_SPINLOCK
 config RWSEM_XCHGADD_ALGORITHM
 	bool
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config HAVE_DEC_LOCK
 	bool
 	default y
diff -puN arch/parisc/Kconfig~frv-make-calibrate_delay-optional arch/parisc/Kconfig
--- 25/arch/parisc/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/parisc/Kconfig	Mon Nov  8 15:00:49 2004
@@ -32,6 +32,10 @@ config RWSEM_GENERIC_SPINLOCK
 config RWSEM_XCHGADD_ALGORITHM
 	bool
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config GENERIC_ISA_DMA
 	bool
 
diff -puN arch/ppc64/Kconfig~frv-make-calibrate_delay-optional arch/ppc64/Kconfig
--- 25/arch/ppc64/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/ppc64/Kconfig	Mon Nov  8 15:00:49 2004
@@ -20,6 +20,10 @@ config RWSEM_XCHGADD_ALGORITHM
 	bool
 	default y
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config GENERIC_ISA_DMA
 	bool
 	default y
diff -puN arch/ppc/Kconfig~frv-make-calibrate_delay-optional arch/ppc/Kconfig
--- 25/arch/ppc/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/ppc/Kconfig	Mon Nov  8 15:00:49 2004
@@ -22,6 +22,10 @@ config RWSEM_XCHGADD_ALGORITHM
 	bool
 	default y
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config HAVE_DEC_LOCK
 	bool
 	default y
diff -puN arch/s390/Kconfig~frv-make-calibrate_delay-optional arch/s390/Kconfig
--- 25/arch/s390/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/s390/Kconfig	Mon Nov  8 15:00:49 2004
@@ -14,6 +14,10 @@ config RWSEM_XCHGADD_ALGORITHM
 	bool
 	default y
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config GENERIC_BUST_SPINLOCK
 	bool
 
diff -puN arch/sh64/Kconfig~frv-make-calibrate_delay-optional arch/sh64/Kconfig
--- 25/arch/sh64/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/sh64/Kconfig	Mon Nov  8 15:00:49 2004
@@ -25,6 +25,10 @@ config RWSEM_GENERIC_SPINLOCK
 	bool
 	default y
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config LOG_BUF_SHIFT
 	int
 	default 14
diff -puN arch/sh/Kconfig~frv-make-calibrate_delay-optional arch/sh/Kconfig
--- 25/arch/sh/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/sh/Kconfig	Mon Nov  8 15:00:49 2004
@@ -25,6 +25,10 @@ config RWSEM_GENERIC_SPINLOCK
 config RWSEM_XCHGADD_ALGORITHM
 	bool
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 source "init/Kconfig"
 
 menu "System type"
diff -puN arch/sparc64/Kconfig~frv-make-calibrate_delay-optional arch/sparc64/Kconfig
--- 25/arch/sparc64/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/sparc64/Kconfig	Mon Nov  8 15:00:49 2004
@@ -186,6 +186,10 @@ config RWSEM_XCHGADD_ALGORITHM
 	bool
 	default y
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 choice
 	prompt "SPARC64 Huge TLB Page Size"
 	depends on HUGETLB_PAGE
diff -puN arch/sparc/Kconfig~frv-make-calibrate_delay-optional arch/sparc/Kconfig
--- 25/arch/sparc/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/sparc/Kconfig	Mon Nov  8 15:00:49 2004
@@ -207,6 +207,10 @@ config RWSEM_GENERIC_SPINLOCK
 config RWSEM_XCHGADD_ALGORITHM
 	bool
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config SUN_PM
 	bool
 	default y
diff -puN arch/um/Kconfig~frv-make-calibrate_delay-optional arch/um/Kconfig
--- 25/arch/um/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/um/Kconfig	Mon Nov  8 15:00:49 2004
@@ -31,6 +31,10 @@ config RWSEM_GENERIC_SPINLOCK
 	bool
 	default y
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 menu "UML-specific options"
 
 config MODE_TT
diff -puN arch/v850/Kconfig~frv-make-calibrate_delay-optional arch/v850/Kconfig
--- 25/arch/v850/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/v850/Kconfig	Mon Nov  8 15:00:49 2004
@@ -19,6 +19,9 @@ config RWSEM_GENERIC_SPINLOCK
 config RWSEM_XCHGADD_ALGORITHM
 	bool
 	default n
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
 
 # Turn off some random 386 crap that can affect device config
 config ISA
diff -puN arch/x86_64/Kconfig~frv-make-calibrate_delay-optional arch/x86_64/Kconfig
--- 25/arch/x86_64/Kconfig~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/arch/x86_64/Kconfig	Mon Nov  8 15:00:49 2004
@@ -41,6 +41,10 @@ config RWSEM_GENERIC_SPINLOCK
 config RWSEM_XCHGADD_ALGORITHM
 	bool
 
+config GENERIC_CALIBRATE_DELAY
+	bool
+	default y
+
 config X86_CMPXCHG
 	bool
 	default y
diff -puN include/asm-m32r/smp.h~frv-make-calibrate_delay-optional include/asm-m32r/smp.h
--- 25/include/asm-m32r/smp.h~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/include/asm-m32r/smp.h	Mon Nov  8 15:00:49 2004
@@ -92,7 +92,6 @@ static __inline__ unsigned int num_booti
 }
 
 extern void smp_send_timer(void);
-extern void calibrate_delay(void);
 extern unsigned long send_IPI_mask_phys(cpumask_t, int, int);
 
 #endif	/* not __ASSEMBLY__ */
diff -puN include/asm-x86_64/proto.h~frv-make-calibrate_delay-optional include/asm-x86_64/proto.h
--- 25/include/asm-x86_64/proto.h~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/include/asm-x86_64/proto.h	Mon Nov  8 15:00:49 2004
@@ -25,7 +25,6 @@ extern void ia32_syscall(void);
 extern void ia32_cstar_target(void); 
 extern void ia32_sysenter_target(void); 
 
-extern void calibrate_delay(void);
 extern void cpu_idle(void);
 extern void config_acpi_tables(void);
 extern void ia32_syscall(void);
diff -puN include/linux/delay.h~frv-make-calibrate_delay-optional include/linux/delay.h
--- 25/include/linux/delay.h~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/include/linux/delay.h	Mon Nov  8 15:00:49 2004
@@ -38,6 +38,7 @@ extern unsigned long loops_per_jiffy;
 #define ndelay(x)	udelay(((x)+999)/1000)
 #endif
 
+void calibrate_delay(void);
 void msleep(unsigned int msecs);
 unsigned long msleep_interruptible(unsigned int msecs);
 
diff -puN /dev/null init/calibrate.c
--- /dev/null	Thu Apr 11 07:25:15 2002
+++ 25-akpm/init/calibrate.c	Mon Nov  8 15:00:49 2004
@@ -0,0 +1,79 @@
+/* calibrate.c: default delay calibration
+ *
+ * Excised from init/main.c
+ *  Copyright (C) 1991, 1992  Linus Torvalds
+ */
+
+#include <linux/sched.h>
+#include <linux/delay.h>
+#include <linux/init.h>
+
+static unsigned long preset_lpj;
+static int __init lpj_setup(char *str)
+{
+	preset_lpj = simple_strtoul(str,NULL,0);
+	return 1;
+}
+
+__setup("lpj=", lpj_setup);
+
+/*
+ * This is the number of bits of precision for the loops_per_jiffy.  Each
+ * bit takes on average 1.5/HZ seconds.  This (like the original) is a little
+ * better than 1%
+ */
+#define LPS_PREC 8
+
+void __devinit calibrate_delay(void)
+{
+	unsigned long ticks, loopbit;
+	int lps_precision = LPS_PREC;
+
+	if (preset_lpj) {
+		loops_per_jiffy = preset_lpj;
+		printk("Calibrating delay loop (skipped)... "
+			"%lu.%02lu BogoMIPS preset\n",
+			loops_per_jiffy/(500000/HZ),
+			(loops_per_jiffy/(5000/HZ)) % 100);
+	} else {
+		loops_per_jiffy = (1<<12);
+
+		printk(KERN_DEBUG "Calibrating delay loop... ");
+		while ((loops_per_jiffy <<= 1) != 0) {
+			/* wait for "start of" clock tick */
+			ticks = jiffies;
+			while (ticks == jiffies)
+				/* nothing */;
+			/* Go .. */
+			ticks = jiffies;
+			__delay(loops_per_jiffy);
+			ticks = jiffies - ticks;
+			if (ticks)
+				break;
+		}
+
+		/*
+		 * Do a binary approximation to get loops_per_jiffy set to
+		 * equal one clock (up to lps_precision bits)
+		 */
+		loops_per_jiffy >>= 1;
+		loopbit = loops_per_jiffy;
+		while (lps_precision-- && (loopbit >>= 1)) {
+			loops_per_jiffy |= loopbit;
+			ticks = jiffies;
+			while (ticks == jiffies)
+				/* nothing */;
+			ticks = jiffies;
+			__delay(loops_per_jiffy);
+			if (jiffies != ticks)	/* longer than 1 tick */
+				loops_per_jiffy &= ~loopbit;
+		}
+
+		/* Round the value and print it */
+		printk("%lu.%02lu BogoMIPS (lpj=%lu)\n",
+			loops_per_jiffy/(500000/HZ),
+			(loops_per_jiffy/(5000/HZ)) % 100,
+			loops_per_jiffy);
+	}
+
+}
diff -puN init/main.c~frv-make-calibrate_delay-optional init/main.c
--- 25/init/main.c~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/init/main.c	Mon Nov  8 15:00:49 2004
@@ -182,15 +182,6 @@ static int __init obsolete_checksetup(ch
 	return 0;
 }
 
-static unsigned long preset_lpj;
-static int __init lpj_setup(char *str)
-{
-	preset_lpj = simple_strtoul(str,NULL,0);
-	return 1;
-}
-
-__setup("lpj=", lpj_setup);
-
 /*
  * This should be approx 2 Bo*oMips to start (note initial shift), and will
  * still work even if initially too large, it will just take slightly longer
@@ -199,67 +190,6 @@ unsigned long loops_per_jiffy = (1<<12);
 
 EXPORT_SYMBOL(loops_per_jiffy);
 
-/*
- * This is the number of bits of precision for the loops_per_jiffy.  Each
- * bit takes on average 1.5/HZ seconds.  This (like the original) is a little
- * better than 1%
- */
-#define LPS_PREC 8
-
-void __devinit calibrate_delay(void)
-{
-	unsigned long ticks, loopbit;
-	int lps_precision = LPS_PREC;
-
-	if (preset_lpj) {
-		loops_per_jiffy = preset_lpj;
-		printk("Calibrating delay loop (skipped)... "
-			"%lu.%02lu BogoMIPS preset\n",
-			loops_per_jiffy/(500000/HZ),
-			(loops_per_jiffy/(5000/HZ)) % 100);
-	} else {
-		loops_per_jiffy = (1<<12);
-
-		printk(KERN_DEBUG "Calibrating delay loop... ");
-		while ((loops_per_jiffy <<= 1) != 0) {
-			/* wait for "start of" clock tick */
-			ticks = jiffies;
-			while (ticks == jiffies)
-				/* nothing */;
-			/* Go .. */
-			ticks = jiffies;
-			__delay(loops_per_jiffy);
-			ticks = jiffies - ticks;
-			if (ticks)
-				break;
-		}
-
-		/*
-		 * Do a binary approximation to get loops_per_jiffy set to
-		 * equal one clock (up to lps_precision bits)
-		 */
-		loops_per_jiffy >>= 1;
-		loopbit = loops_per_jiffy;
-		while (lps_precision-- && (loopbit >>= 1)) {
-			loops_per_jiffy |= loopbit;
-			ticks = jiffies;
-			while (ticks == jiffies)
-				/* nothing */;
-			ticks = jiffies;
-			__delay(loops_per_jiffy);
-			if (jiffies != ticks)	/* longer than 1 tick */
-				loops_per_jiffy &= ~loopbit;
-		}
-
-		/* Round the value and print it */
-		printk("%lu.%02lu BogoMIPS (lpj=%lu)\n",
-			loops_per_jiffy/(500000/HZ),
-			(loops_per_jiffy/(5000/HZ)) % 100,
-			loops_per_jiffy);
-	}
-
-}
-
 static int __init debug_kernel(char *str)
 {
 	if (*str)
diff -puN init/Makefile~frv-make-calibrate_delay-optional init/Makefile
--- 25/init/Makefile~frv-make-calibrate_delay-optional	Mon Nov  8 15:00:49 2004
+++ 25-akpm/init/Makefile	Mon Nov  8 15:00:49 2004
@@ -3,6 +3,8 @@
 #
 
 obj-y				:= main.o version.o mounts.o initramfs.o
+obj-$(CONFIG_GENERIC_CALIBRATE_DELAY) += calibrate.o
+
 mounts-y			:= do_mounts.o
 mounts-$(CONFIG_DEVFS_FS)	+= do_mounts_devfs.o
 mounts-$(CONFIG_BLK_DEV_RAM)	+= do_mounts_rd.o
_
